/************************************************************************************/
/*  Program name CAPFAEXT_MASS_ADDITIONS.sql                                        */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 28 DEC, 2005   NIP Karen         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_MASS_ADDITIONS';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_MASS_ADDITIONS.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_MASS_ADDITIONS
	WHERE	SUBSTR(Book_Type_Code,1,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.MASS_ADDITION_ID||CHR(9)||
				C1.ASSET_NUMBER||CHR(9)||
				C1.TAG_NUMBER||CHR(9)||
				C1.DESCRIPTION||CHR(9)||
				C1.ASSET_CATEGORY_ID||CHR(9)||
				C1.MANUFACTURER_NAME||CHR(9)||
				C1.SERIAL_NUMBER||CHR(9)||
				C1.MODEL_NUMBER||CHR(9)||
				C1.BOOK_TYPE_CODE||CHR(9)||
				C1.DATE_PLACED_IN_SERVICE||CHR(9)||
				C1.FIXED_ASSETS_COST||CHR(9)||
				C1.PAYABLES_UNITS||CHR(9)||
				C1.FIXED_ASSETS_UNITS||CHR(9)||
				C1.PAYABLES_CODE_COMBINATION_ID||CHR(9)||
				C1.EXPENSE_CODE_COMBINATION_ID||CHR(9)||
				C1.LOCATION_ID||CHR(9)||
				C1.ASSIGNED_TO||CHR(9)||
				C1.FEEDER_SYSTEM_NAME||CHR(9)||
				C1.CREATE_BATCH_DATE||CHR(9)||
				C1.CREATE_BATCH_ID||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
				C1.LAST_UPDATED_BY||CHR(9)||
				C1.REVIEWER_COMMENTS||CHR(9)||
				C1.INVOICE_NUMBER||CHR(9)||
				C1.VENDOR_NUMBER||CHR(9)||
				C1.PO_VENDOR_ID||CHR(9)||
				C1.PO_NUMBER||CHR(9)||
				C1.POSTING_STATUS||CHR(9)||
				C1.QUEUE_NAME||CHR(9)||
				C1.INVOICE_DATE||CHR(9)||
				C1.INVOICE_CREATED_BY||CHR(9)||
				C1.INVOICE_UPDATED_BY||CHR(9)||
				C1.PAYABLES_COST||CHR(9)||
				C1.INVOICE_ID||CHR(9)||
				C1.PAYABLES_BATCH_NAME||CHR(9)||
				C1.DEPRECIATE_FLAG||CHR(9)||
				C1.PARENT_MASS_ADDITION_ID||CHR(9)||
				C1.PARENT_ASSET_ID||CHR(9)||
				C1.SPLIT_MERGED_CODE||CHR(9)||
				C1.AP_DISTRIBUTION_LINE_NUMBER||CHR(9)||
				C1.POST_BATCH_ID||CHR(9)||
				C1.ADD_TO_ASSET_ID||CHR(9)||
				C1.AMORTIZE_FLAG||CHR(9)||
				C1.NEW_MASTER_FLAG||CHR(9)||
				C1.ASSET_KEY_CCID||CHR(9)||
				C1.ASSET_TYPE||CHR(9)||
				C1.DEPRN_RESERVE||CHR(9)||
				C1.YTD_DEPRN||CHR(9)||
				C1.BEGINNING_NBV||CHR(9)||
				C1.CREATED_BY||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.SALVAGE_VALUE||CHR(9)||
				C1.ACCOUNTING_DATE||CHR(9)||
				C1.ATTRIBUTE1||CHR(9)||
				C1.ATTRIBUTE2||CHR(9)||
				C1.ATTRIBUTE3||CHR(9)||
				C1.ATTRIBUTE4||CHR(9)||
				C1.ATTRIBUTE5||CHR(9)||
				C1.ATTRIBUTE6||CHR(9)||
				C1.ATTRIBUTE7||CHR(9)||
				C1.ATTRIBUTE8||CHR(9)||
				C1.ATTRIBUTE9||CHR(9)||
				C1.ATTRIBUTE10||CHR(9)||
				C1.ATTRIBUTE11||CHR(9)||
				C1.ATTRIBUTE12||CHR(9)||
				C1.ATTRIBUTE13||CHR(9)||
				C1.ATTRIBUTE14||CHR(9)||
				C1.ATTRIBUTE15||CHR(9)||
				C1.ATTRIBUTE_CATEGORY_CODE||CHR(9)||
				C1.FULLY_RSVD_REVALS_COUNTER||CHR(9)||
				C1.MERGE_INVOICE_NUMBER||CHR(9)||
				C1.MERGE_VENDOR_NUMBER||CHR(9)||
				C1.PRODUCTION_CAPACITY||CHR(9)||
				C1.REVAL_AMORTIZATION_BASIS||CHR(9)||
				C1.REVAL_RESERVE||CHR(9)||
				C1.UNIT_OF_MEASURE||CHR(9)||
				C1.UNREVALUED_COST||CHR(9)||
				C1.YTD_REVAL_DEPRN_EXPENSE||CHR(9)||
				C1.ATTRIBUTE16||CHR(9)||
				C1.ATTRIBUTE17||CHR(9)||
				C1.ATTRIBUTE18||CHR(9)||
				C1.ATTRIBUTE19||CHR(9)||
				C1.ATTRIBUTE20||CHR(9)||
				C1.ATTRIBUTE21||CHR(9)||
				C1.ATTRIBUTE22||CHR(9)||
				C1.ATTRIBUTE23||CHR(9)||
				C1.ATTRIBUTE24||CHR(9)||
				C1.ATTRIBUTE25||CHR(9)||
				C1.ATTRIBUTE26||CHR(9)||
				C1.ATTRIBUTE27||CHR(9)||
				C1.ATTRIBUTE28||CHR(9)||
				C1.ATTRIBUTE29||CHR(9)||
				C1.ATTRIBUTE30||CHR(9)||
				C1.MERGED_CODE||CHR(9)||
				C1.SPLIT_CODE||CHR(9)||
				C1.MERGE_PARENT_MASS_ADDITIONS_ID||CHR(9)||
				C1.SPLIT_PARENT_MASS_ADDITIONS_ID||CHR(9)||
				C1.PROJECT_ASSET_LINE_ID||CHR(9)||
				C1.PROJECT_ID||CHR(9)||
				C1.TASK_ID||CHR(9)||
				C1.SUM_UNITS||CHR(9)||
				C1.DIST_NAME||CHR(9)||
				C1.GLOBAL_ATTRIBUTE1||CHR(9)||
				C1.GLOBAL_ATTRIBUTE2||CHR(9)||
				C1.GLOBAL_ATTRIBUTE3||CHR(9)||
				C1.GLOBAL_ATTRIBUTE4||CHR(9)||
				C1.GLOBAL_ATTRIBUTE5||CHR(9)||
				C1.GLOBAL_ATTRIBUTE6||CHR(9)||
				C1.GLOBAL_ATTRIBUTE7||CHR(9)||
				C1.GLOBAL_ATTRIBUTE8||CHR(9)||
				C1.GLOBAL_ATTRIBUTE9||CHR(9)||
				C1.GLOBAL_ATTRIBUTE10||CHR(9)||
				C1.GLOBAL_ATTRIBUTE11||CHR(9)||
				C1.GLOBAL_ATTRIBUTE12||CHR(9)||
				C1.GLOBAL_ATTRIBUTE13||CHR(9)||
				C1.GLOBAL_ATTRIBUTE14||CHR(9)||
				C1.GLOBAL_ATTRIBUTE15||CHR(9)||
				C1.GLOBAL_ATTRIBUTE16||CHR(9)||
				C1.GLOBAL_ATTRIBUTE17||CHR(9)||
				C1.GLOBAL_ATTRIBUTE18||CHR(9)||
				C1.GLOBAL_ATTRIBUTE19||CHR(9)||
				C1.GLOBAL_ATTRIBUTE20||CHR(9)||
				C1.GLOBAL_ATTRIBUTE_CATEGORY||CHR(9)||
				C1.CONTEXT||CHR(9)||
				C1.INVENTORIAL||CHR(9)||
				C1.SHORT_FISCAL_YEAR_FLAG||CHR(9)||
				C1.CONVERSION_DATE||CHR(9)||
				C1.ORIGINAL_DEPRN_START_DATE||CHR(9)||
				C1.GROUP_ASSET_ID||CHR(9)||
				C1.CUA_PARENT_HIERARCHY_ID||CHR(9)||
				C1.UNITS_TO_ADJUST||CHR(9)||
				C1.BONUS_YTD_DEPRN||CHR(9)||
				C1.BONUS_DEPRN_RESERVE||CHR(9)||
				C1.AMORTIZE_NBV_FLAG||CHR(9)||
				C1.AMORTIZATION_START_DATE||CHR(9)||
				C1.TRANSACTION_TYPE_CODE||CHR(9)||
				C1.TRANSACTION_DATE||CHR(9)||
				C1.WARRANTY_ID||CHR(9)||
				C1.LEASE_ID||CHR(9)||
				C1.LESSOR_ID||CHR(9)||
				C1.PROPERTY_TYPE_CODE||CHR(9)||
				C1.PROPERTY_1245_1250_CODE||CHR(9)||
				C1.IN_USE_FLAG||CHR(9)||
				C1.OWNED_LEASED||CHR(9)||
				C1.NEW_USED||CHR(9)||
				C1.ASSET_ID||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.PAYABLES_CODE_COMBINATION_ID)||CHR(9)||
	            CAPBREXT_COMMON.GetSegment(C1.EXPENSE_CODE_COMBINATION_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
